#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Deploys Banking ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop

#########################################################################
# Get Derby DB DSN properties
#########################################################################
jndiName = prop.getProperty('jndiName')
wicpDatabaseName = prop.getProperty('wicpDatabaseName')
wicpDbHostName = prop.getProperty('wicpDbHostName')
wicpDbUser = prop.getProperty('wicpDbUser')
wicpDbPassword = prop.getProperty('wicpDbPassword')

#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppName = prop.getProperty('refEarAppName')
refEarFileName = prop.getProperty('refEarFileName')

mockEarAppName = prop.getProperty('mockEarAppName')
mockEarFileName = prop.getProperty('mockEarFileName')
#########################################################################
print "Monitor Model and ear properties loaded."

#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupNameAdamCustomer = prop.getProperty('groupNameAdamCustomer')
groupNameJayBankOfficer = prop.getProperty('groupNameJayBankOfficer')
groupNameSusanLOBManager = prop.getProperty('groupNameSusanLOBManager')
groupNamePeterBankManager = prop.getProperty('groupNamePeterBankManager')

userName01Adam = prop.getProperty('userName01Adam')
userName02Jay = prop.getProperty('userName02Jay')
surName01Smith = prop.getProperty('surName01Smith')
surName02Walk = prop.getProperty('surName02Walk')
userName03Peter = prop.getProperty('userName03Peter')
surName03Henderson = prop.getProperty('surName03Henderson')
userName04Susan = prop.getProperty('userName04Susan')
surName04Thomas = prop.getProperty('surName04Thomas')

#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
#nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')
createCubes = prop.getProperty('createCubes')
startCubes = prop.getProperty('startCubes')
businessSituation = prop.getProperty('businessSituation')
profileMigration = prop.getProperty('profileMigration')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppName, mockEarAppName, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)

#Deploy the Banking application
#########################################################################
# Install Ref app EAR
#########################################################################
print
print "Installing Reference Implementation application ... " + refEarAppName
try :
        appOptions = ["-appname", refEarAppName, "-server", serverName]
	AdminApp.install(refEarFileName, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppName"
        sys.stderr.write("Error occured while deploying refEarAppName")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppName)
print "Ear started: " + refEarAppName
print refEarAppName + " installed successfully."

print
try :
        appOptions = ["-appname", mockEarAppName, "-server", serverName]
	AdminApp.install(mockEarFileName, appOptions)

except :
        print "Exception:Error occured while deploying mockEarAppName"
        sys.stderr.write("Error occured while deploying mockEarAppName")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', mockEarAppName)
print "Ear started: " + mockEarAppName
print mockEarAppName + " installed successfully."

#########################################################################
# Install Monitor Model EARs
#########################################################################
print
print "Installing Monitor Model application ..."

# The LifecycleClientDatabaseTask task consists of the following 6 fields
# and the acceptable values:
#   "Run scripts to create the schema" = yes or no
#   "Run scripts to enable Data Movement Services" = yes or no
#   "Run scripts to delete the schema during uninstallation" = yes or no
#   "Processing strategy" = SerialST or SerialMT
#   "Enable event reordering" = yes or no
#   "Enable KPI merge from previous version" = yes or no
createSchema = 'yes'
enableDMS = 'no'
deleteSchema = 'yes'
processingStrategy = 'SerialMT'
eventReordering = 'no'
kpiMerge = 'no'
businessSituation = 'yes'
profileMigration = 'no'

 # Alphablox settings

 # 1.  The LifecycleClientAlphabloxTask task consists of the following 8 fields
 # 2. and the acceptable values:
 # 3. "Server location (local/remote)" = local or remote
 # 4. default is local
 # 5. "Host name, ignored if location is local"= hostname
 # 6. "RMI port, ignored if location is local" = port number
 # 7. "Security (enabled/disabled), ignored if location is local" = enabled or disabled
 # 8. default is disabled
 # 9. "User ID, ignored if security is disabled" = user ID
 # 10. "Password, ignored if security is disabled" = password
 # 11. "Create the Alphablox cubes" = yes or no
 # 12. default is yes if Alphablox is local
 # 13. "Start the Alphablox cubes" = should be the same value as "Create the Alphablox cubes"
serverLocation = 'local'
hostName = ''
rmiPort = ''
securityMode = 'enabled'
userid = 'admin'
password = 'admin'
createCubes = 'yes'
startCubes = 'yes'

databaseTaskInfo = [ createSchema, enableDMS, deleteSchema, processingStrategy, eventReordering, kpiMerge, businessSituation, profileMigration ]
alphabloxTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, createCubes, startCubes ]

print AdminControl.trace('com.ibm.wbimonitor.*=all=enabled')

print
print "Installing Monitor Model application ..."
# Install Monitor Model EAR
if serverLocation == 'local':
   cellName = cell
   nodeName = node
   serverName = server
elif serverLocation == 'remote':
   print "Installing Monitor Model on remote Monitor server..." 
else:
   print "Please set CEI server location in configration properties file"
   sys.exit(1)

ceiTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, \
   eventGroup, cellName, nodeName, serverName, clusterName, distributionMode ]
try :
	AdminApp.install(mmEarFileName,  ['-LifecycleClientDatabaseTask', [databaseTaskInfo], \
	'-LifecycleClientAlphabloxTask', [alphabloxTaskInfo], \
	'-LifecycleClientCEITask', [ceiTaskInfo], '-appname', mmAppName]  )

except :
        print "Exception:Error occured while deploying mmAppName"
        sys.stderr.write("Error occured while deploying mmAppName")
        raise
        print "Deployed Monitor Model ears."

# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', mmAppName)
print "Ear started: " + mmAppName
print mmAppName + " installed successfully."

#########################################################################
# Creating user and group and their mapping
#########################################################################
print
print "Creating Users and Groups and associating them ..."
try :
        
	attrGrpCustomer = ["-cn",groupNamePeterBankManager]
	if(len(AdminTask.searchGroups(attrGrpCustomer)) > 1):
	    print "Skipping creating group " +  groupNamePeterBankManager + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpCustomer)

	attrGrpUnderWriter = ["-cn",groupNameSusanLOBManager]
	if(len(AdminTask.searchGroups(attrGrpUnderWriter)) > 1):
	    print "Skipping creating group " +  groupNameSusanLOBManager + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpUnderWriter)

	attrGrpAgent = ["-cn",groupNameAdamCustomer]
	if(len(AdminTask.searchGroups(attrGrpAgent)) > 1):
	    print "Skipping creating group " +  groupNameAdamCustomer + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpAgent)
	
	attrGrpLoanOfficer = ["-cn",groupNameJayBankOfficer]
	if(len(AdminTask.searchGroups(attrGrpLoanOfficer)) > 1):
	    print "Skipping creating group " +  groupNameJayBankOfficer + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpLoanOfficer)

	attrName1 = ["-uid",userName01Adam]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
            print "Skipping creating user " +  userName01Adam + " as user exists"
	else :
	    appOptions = ["-uid", userName01Adam, "-password", "password", "-confirmPassword", "password", "-cn", userName01Adam, "-sn", surName01Smith]
	    AdminTask.createUser(appOptions)
	    attrName1 = ["-uid",userName01Adam]
	    userStr1 = AdminTask.searchUsers(attrName1)
	    groupStr = AdminTask.searchGroups(attrGrpAgent)
	    appOptions = ["-memberUniqueName", userStr1, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	
	attrName2 = ["-uid",userName02Jay]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
            print "Skipping creating user " +  userName02Jay + " as user exists"
	else :
	    appOptions = ["-uid", userName02Jay, "-password", "password", "-confirmPassword", "password", "-cn", userName02Jay, "-sn", surName02Walk]
	    AdminTask.createUser(appOptions)
	    attrName2 = ["-uid",userName02Jay]
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    groupStr = AdminTask.searchGroups(attrGrpLoanOfficer)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)
	
	attrName3 = ["-uid",userName03Peter]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
            print "Skipping creating user " +  userName03Peter + " as user exists"
	else :
	    appOptions = ["-uid", userName03Peter, "-password", "password", "-confirmPassword", "password", "-cn", userName03Peter, "-sn", surName03Henderson]
	    AdminTask.createUser(appOptions)
	    attrName3 = ["-uid",userName03Peter]
	    userStr3 = AdminTask.searchUsers(attrName3)
	    groupStr = AdminTask.searchGroups(attrGrpCustomer)
	    appOptions = ["-memberUniqueName", userStr3, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	
	attrName4 = ["-uid",userName04Susan]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
            print "Skipping creating user " +  userName04Susan + " as user exists"
	else :
	    appOptions = ["-uid", userName04Susan, "-password", "password", "-confirmPassword", "password", "-cn", userName04Susan, "-sn", surName04Thomas]
	    AdminTask.createUser(appOptions)
	    attrName4 = ["-uid",userName04Susan]
	    userStr4 = AdminTask.searchUsers(attrName4)
	    groupStr = AdminTask.searchGroups(attrGrpUnderWriter)
	    appOptions = ["-memberUniqueName", userStr4, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)

except :
        print "Exception:Error occured while Group user creation and mapping"
        sys.stderr.write("Error occured while Group user creation and mapping")
        raise
        print "Group groupNamePeterBankManager"

#########################################################################
# Creating user and group and their mapping done
#########################################################################

#########################################################################
# Creating WICP Data Source Name
#########################################################################

def createDataSource(providerId,templateDSId,name,jndiName,helperName,authAlias):
    nameAttr = ["name", name]
    jndiAttr = ["jndiName", jndiName]
    statementCacheSizeAttr = ["statementCacheSize","100"]
    helpAttr = ["datasourceHelperClassname", helperName]
    authAttr = ["authDataAlias", authAlias]
    datasourceCreateArgs = [nameAttr, jndiAttr, statementCacheSizeAttr, helpAttr, authAttr]
    return AdminConfig.create("DataSource", providerId, datasourceCreateArgs)

def createUpdateWicpDataSource(providerId,templateDSId,name,jndi,datasourceHelperClassname,resourceAttrs,wicpJ2CAuth,scopeId,scope) :
    ds = findDataSource(jndi,scopeId,scope)
    if(ds == "") :
        print "Creating Datasource with JNDI Name at scope - " + scopeId
        ds = createDataSource(providerId,templateDSId,name,jndi,datasourceHelperClassname,wicpJ2CAuth)
    else :
        print "Existing Datasource found with JNDI Name " + str(jndi) + " at scope - " + scopeId
        #User would have changed dbTypes, hence removing old one.
        AdminConfig.remove(ds)
        print "Creating new Datasource with JNDI Name " + str(jndi) + " at scope - " + scopeId
        ds = createDataSource(providerId,templateDSId,name,jndi,datasourceHelperClassname,wicpJ2CAuth)
    AdminConfig.modify(ds,resourceAttrs) 


##########################################################
#Get Datasources based on JNDIname and scope.
##########################################################
def findDataSource(jndiName,scopeId,scope):

    dataSourceList = AdminConfig.list("DataSource", scopeId).split(lineSeparator)
    for dsentry in dataSourceList :
        dsJndiName = AdminConfig.showAttribute(dsentry,"jndiName")
        if(dsJndiName == jndiName) :
	        provider = AdminConfig.showAttribute(dsentry,"provider")
	        provideName = AdminConfig.showAttribute(provider,"name")
	        dataSourceName = AdminConfig.showAttribute(dsentry,"name")
	        path = scope + "JDBCProvider:"+ provideName + "/DataSource:" + dataSourceName+"/"
	        dataSource = AdminConfig.getid(path)
	        if(dataSource != "") :
	            return dataSource
    return ""

##############################################################
# Get JDBC Provider Configuration
#############################################################

def getJdbcProviderConfigId(scope, providerName):
    providerConfigId = AdminConfig.getid(scope + "JDBCProvider:" + providerName + "/").splitlines()
    if (providerConfigId == ""):
        print "Did not find JDBC Provider: " + providerName
        return None
    else:
        for provider in providerConfigId:
            print "provider" +str(provider)
            return provider


def getJdbcTemplateId(templateName):
    templateList = AdminConfig.listTemplates('JDBCProvider',templateName).splitlines()
    for temp in templateList :
        return temp
###########################################################
# Prints error message on the console
###########################################################
def validationError (errorMessage) :
    sys.stderr.write(errorMessage)
    print "Exception:validationError - " + str(errorMessage)
    sys.exit()
##########################################################
#Create JAASAuthData
##########################################################

def createJAASAuthData(alias,userId,password):
    authObj = getJAASAuthData(alias)
    aliasAttr = ['alias', alias]
    useridAttr = ['userId', userId]
    passwordAttr = ['password', password]
    jaasAttrs = [aliasAttr, useridAttr, passwordAttr]
    if(len(authObj) > 1):
        #Update the values
        print "Found Alias" + str(alias)
        AdminConfig.modify(authObj,jaasAttrs)
    else :
        security = AdminConfig.getid('/Cell:'+ cellName +'/Security:/')
        #Create Auth Alias
        print "Created J2C Auth" + alias
        AdminConfig.create('JAASAuthData', security, jaasAttrs)

##########################################################
#Get JASSAuthData based on Auth Alias
##########################################################

def getJAASAuthData(aliasAuth) :
    authObj = ""
    aliasidlist = AdminConfig.list("JAASAuthData").split(lineSeparator)
    for aliasid in aliasidlist:
        qualifiedaliasName = AdminConfig.showAttribute(aliasid,"alias")
        i= qualifiedaliasName.find('/')
        name=qualifiedaliasName[i+1:len(qualifiedaliasName)]
        if (name==aliasAuth):
            authObj = aliasid
            break
    return authObj



#main()

###################################################################
# Command line parameters passed in. Evaluate each of these paramters
###################################################################

nextArg = 0;
while(len(sys.argv) > nextArg) :
    param = sys.argv[nextArg]
    nextArg +=1
    value = sys.argv[nextArg]
    nextArg +=1
    if (param == "-nodeName"):
        nodeName = value
    elif (param == "-cellName"):
        cellName = value

nodeId=AdminConfig.getid("/Node:"+nodeName+"/")

if (nodeId==""):
    validationError("Node "+ nodeName + "doesn't exist")

servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverName =  AdminConfig.showAttribute(serversList[0], "name")
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")

if (serverId==""):
    validationError("Server "+ serverName + " doesn't exist")

#finding the server id & name
servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
#finding scope
scope = "/Node:"+nodeName+"/Server:"+serverName+"/"
scopeId = serverId

wicpDB="WICP_DB"
wicpJ2CAuth = "WICP_JDBC_AUTH"

#Creating the JASSAuthData
createJAASAuthData(wicpJ2CAuth,wicpDbUser,wicpDbPassword)

newsprops = []
template ="Derby JDBC Provider (XA)"
templateDSName = "Derby JDBC Driver XA DataSource"
templateDSId = AdminConfig.listTemplates("DataSource", templateDSName)
datasourceHelperClassname = "com.ibm.websphere.rsadapter.DerbyDataStoreHelper"
dbnameAttr = [["name", "databaseName"], ["value", "${USER_INSTALL_ROOT}/databases/WICPDB"], ["type", "java.lang.String"]]
newsprops.append(dbnameAttr)
psAttr = ["propertySet", [["resourceProperties", newsprops]]]
resourceAttrs = [psAttr]
#Get Provider Template
templateId = getJdbcTemplateId(template)

providerId = getJdbcProviderConfigId(scope,template)
print "Got providerId" + str(providerId)

#Create JDBC Provider

if((providerId == None)):
    #Create Fabric JDBC Provider.
    print "Create Fabric JDBC Provider"
    providerCreateArgs = [["name", "WICP Datasource"]]
    print "scopeId",scopeId
    print "providerCreateArgs",providerCreateArgs
    print "templateId",templateId
    providerId = AdminConfig.createUsingTemplate("JDBCProvider", scopeId, providerCreateArgs,templateId)
    print "created providerId",providerId

createUpdateWicpDataSource(providerId,templateId,wicpDB,jndiName,datasourceHelperClassname,resourceAttrs,wicpJ2CAuth,scopeId,scope)


#########################################################################
# Datasource creation is done.
#########################################################################


#########################################################################
# Monitor Model Role Mapping begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName01Adam + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName01Adam + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01Adam + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName01Adam + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01Adam + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName01Adam + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01Adam + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName01Adam + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName02Jay + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName02Jay + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02Jay + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName02Jay + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02Jay + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName02Jay + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02Jay + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName02Jay + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName03Peter + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName03Peter + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03Peter + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName03Peter + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03Peter + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName03Peter + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03Peter + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName03Peter + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName04Susan + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName04Susan + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04Susan + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName04Susan + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04Susan + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName04Susan + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04Susan + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName04Susan + "to role KPI-Administrator"


#########################################################################
# Monitor Model Role Mapping is done.
#########################################################################



#######################################################################
# #Save configuration
#######################################################################
AdminConfig.save()
print "All the configurations are saved .."
#######################################################################
# End of file.
#######################################################################