#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Uninstalls Banking ICP ears, deletes Users and Groups.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop

#########################################################################
# Get Derby DB DSN properties
#########################################################################
jndiName = prop.getProperty('jndiName')
wicpDatabaseName = prop.getProperty('wicpDatabaseName')
wicpDbHostName = prop.getProperty('wicpDbHostName')
wicpDbUser = prop.getProperty('wicpDbUser')
wicpDbPassword = prop.getProperty('wicpDbPassword')

#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppName = prop.getProperty('refEarAppName')
refEarFileName = prop.getProperty('refEarFileName')

mockEarAppName = prop.getProperty('mockEarAppName')
mockEarFileName = prop.getProperty('mockEarFileName')
#########################################################################
print "Monitor Model and ear properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupNameAdamCustomer = prop.getProperty('groupNameAdamCustomer')
groupNameJayBankOfficer = prop.getProperty('groupNameJayBankOfficer')
groupNameSusanLOBManager = prop.getProperty('groupNameSusanLOBManager')
groupNamePeterBankManager = prop.getProperty('groupNamePeterBankManager')

userName01Adam = prop.getProperty('userName01Adam')
userName02Jay = prop.getProperty('userName02Jay')
surName01Smith = prop.getProperty('surName01Smith')
surName02Walk = prop.getProperty('surName02Walk')
userName03Peter = prop.getProperty('userName03Peter')
surName03Henderson = prop.getProperty('surName03Henderson')
userName04Susan = prop.getProperty('userName04Susan')
surName04Thomas = prop.getProperty('surName04Thomas')

#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppName, mockEarAppName, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)
#########################################################################
# Deleting users, groups and their mapping
#########################################################################
print
print "Deleting users, groups and their mapping ..."
try :
	attrName1 = ["-uid",userName03Peter]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
	    print "Deleting user " + userName03Peter + " with group"
	    userStr1 =  AdminTask.searchUsers(attrName1)
	    attrGrp = ["-cn",groupNamePeterBankManager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName03Peter + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName03Peter
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNamePeterBankManager	
	else :
	    print "User " + userName03Peter + " does not exist" 

	attrName2 = ["-uid",userName04Susan]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
	    print "Deleting user " + userName04Susan + " with group"
	    userStr1 =  AdminTask.searchUsers(attrName2)
	    attrGrp = ["-cn",groupNameSusanLOBManager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName04Susan + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName04Susan
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameSusanLOBManager	    
	else :
	    print "User " + userName04Susan + " does not exist" 

	attrName3 = ["-uid",userName01Adam]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
	    print "Deleting user " + userName01Adam + " with group"
	    userStr1 =  AdminTask.searchUsers(attrName3)
	    attrGrp = ["-cn",groupNameAdamCustomer]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName01Adam + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName01Adam
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameAdamCustomer	    
	else :
	    print "User " + userName01Adam + " does not exist" 

	attrName4 = ["-uid",userName02Jay]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
	    print "Deleting user " + userName02Jay + " with group"
	    userStr1 =  AdminTask.searchUsers(attrName4)
	    attrGrp = ["-cn",groupNameJayBankOfficer]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName02Jay + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName02Jay
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameJayBankOfficer	    
	else :
	    print "User " + userName02Jay + " does not exist"

except :
        print "Exception:Error occured while deleting users, groups and their mapping "
        sys.stderr.write("Error occured while deleting users, groups and their mapping ")
        raise
        	
AdminConfig.save()

#########################################################################
# Removing Datasource
#########################################################################

##########################################################
#Get Datasources based on JNDIname and scope.
##########################################################
def findDataSource(jndiName,scopeId,scope):

    dataSourceList = AdminConfig.list("DataSource", scopeId).split(lineSeparator)
    for dsentry in dataSourceList :
        dsJndiName = AdminConfig.showAttribute(dsentry,"jndiName")
        if(dsJndiName == jndiName) :
	        provider = AdminConfig.showAttribute(dsentry,"provider")
	        provideName = AdminConfig.showAttribute(provider,"name")
	        dataSourceName = AdminConfig.showAttribute(dsentry,"name")
	        path = scope + "JDBCProvider:"+ provideName + "/DataSource:" + dataSourceName+"/"
	        dataSource = AdminConfig.getid(path)
	        if(dataSource != "") :
	            return dataSource
    return ""

###################################################################
# Command line parameters passed in. Evaluate each of these paramters
###################################################################

nextArg = 0;
while(len(sys.argv) > nextArg) :
    param = sys.argv[nextArg]
    nextArg +=1
    value = sys.argv[nextArg]
    nextArg +=1
    if (param == "-nodeName"):
        nodeName = value
    elif (param == "-cellName"):
        cellName = value

nodeId=AdminConfig.getid("/Node:"+nodeName+"/")

if (nodeId==""):
    validationError("Node "+ nodeName + "doesn't exist")

servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverName =  AdminConfig.showAttribute(serversList[0], "name")
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")

if (serverId==""):
    validationError("Server "+ serverName + " doesn't exist")

#finding the server id & name
servers = AdminConfig.list("Server", nodeId)
serversList = servers.split(lineSeparator)
serverId=AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
#finding scope
scope = "/Node:"+nodeName+"/Server:"+serverName+"/"
scopeId = serverId

ds = findDataSource(jndiName,scopeId,scope)

if(ds != "") :
    print ""
    print "Removing DSN configuration for WICPDB ..."
    AdminConfig.remove(ds)
    print "Done"



#########################################################################
# Monitor Model Role Mapping removal begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.removeRole("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName01Adam + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName01Adam + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01Adam + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01Adam + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01Adam + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01Adam + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01Adam+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01Adam + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01Adam + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName02Jay + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName02Jay + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02Jay + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02Jay + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02Jay + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02Jay + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02Jay+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02Jay + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02Jay + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName03Peter + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName03Peter + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03Peter + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03Peter + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03Peter + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03Peter + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03Peter+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03Peter + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03Peter + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName04Susan + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName04Susan + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04Susan + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04Susan + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04Susan + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04Susan + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04Susan+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04Susan + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04Susan + "to role KPI-Administrator"


#########################################################################
# Monitor Model Role Mapping removed.
#########################################################################

AdminConfig.save()
#########################################################################
# End of file.
#########################################################################